def wypisz(tablica):
    print(' '.join([str(m) for m in tablica]))

def rozwiaz():
    n, k = [int(m) for m in input().split()]
    zbior = sorted([int(m) for m in input().split()])
    wynik = []
    poczatek = 0
    koniec = n - 1
    niedobor = k
    if k % 2 == 1:
        if zbior[koniec] <= 0:
            wypisz(zbior[-k:n])
            return
        wynik.append(zbior[koniec])
        koniec -= 1
        niedobor -= 1
    while niedobor > 0:
        if zbior[poczatek] * zbior[poczatek + 1] > zbior[koniec] * zbior[koniec - 1]:
            wynik.append(zbior[poczatek])
            wynik.append(zbior[poczatek + 1])
            poczatek += 2
        else:
            wynik.append(zbior[koniec])
            wynik.append(zbior[koniec - 1])
            koniec -= 2
        niedobor -= 2
    if 0 in wynik:
        wypisz(zbior[-k:n])
        return
    wynik.sort()
    wypisz(wynik)

rozwiaz()